<?php
/**
 * @package		AdsManager
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license		GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_adsmanager'.DS.'tables');

/**
 * @package		Joomla
 * @subpackage	Contact
 */
class AdsmanagerModelCategory extends JModel
{
	public function getCategory($id) {
    	$this->_db->setQuery( "SELECT * FROM #__adsmanager_categories WHERE id = ".(int)$id);
		$cat = $this->_db->loadObject();
		return $cat;
    }
    
	public function getCategories($onlyPublished = true) {
		
		if ($onlyPublished == true)
			$published = " c.published = 1 ";
		else
			$published = " 1 ";
    	$this->_db->setQuery( "SELECT c.* FROM #__adsmanager_categories as c ".
							 "WHERE $published ORDER BY c.parent,c.ordering");
		$cats = $this->_db->loadObjectList();
		return $cats;
    }
    
	function getPathList($catid,$itemid=0){
		$cats = $this->getCategories();
		$orderlist = array();
		$list = array();
		if(isset($cats))
		{
			foreach ($cats as $c ) {
				$orderlist[$c->id] = $c;
			}
		
			if (($catid != -1)&&($catid != 0))
			{
				$i=0;
				$list[$i]->text   = $orderlist[$catid]->name;
				$list[$i]->link   = JRoute::_('index.php?option=com_adsmanager&view=list&catid='.$catid.'&Itemid='.$itemid);
				$i++;
		
				$current = $catid;
				
				while($orderlist[$current]->parent != 0)
				{
					$current = $orderlist[$current]->parent;
					$list[$i]->text   = $orderlist[$current]->name;
					$list[$i]->link   = JRoute::_('index.php?option=com_adsmanager&view=list&catid='.$orderlist[$current]->id.'&Itemid='.$itemid);
					$i++;	
				}
			}
		}
		$nb = count($list);
		if ($catid == 0)
			$list[$nb]->link = JRoute::_('index.php?option=com_adsmanager&Itemid='.$itemid);
		else
			$list[$nb]->link = JRoute::_('index.php?option=com_adsmanager&view=list&Itemid='.$itemid);
		$list[$nb]->text = JText::_('ADSMANAGER_ROOT_TITLE');
		
		return $list;
	}
    
    public function getSubCats($parentid) {
    	$this->_db->setQuery( "SELECT c.* FROM #__adsmanager_categories as c ".
							 "WHERE c.parent = ".(int)$parentid." AND c.published = 1 ORDER BY c.ordering");
		$cats = $this->_db->loadObjectList();
		return $cats;
    }
    
	function getNbCats($onlyPublished = true)
	{
		if ($onlyPublished == true)
			$published = " c.published = 1 ";
		else
			$published = " 1 ";
			
		$query =  " SELECT count(*) FROM #__adsmanager_categories as c ".
				  " WHERE $published";
		$this->_db->setQuery($query);				 
		$nb = $this->_db->loadResult();
		return $nb;
	}
	
	function getCatTree($onlyPublished = true,&$nbcontents=null) {
		
		if ($onlyPublished == true)
			$published = " c.published = 1 ";
		else
			$published = " 1 ";
							
		$query =  "SELECT c.*, count(*) as num_ads,a.id as not_empty ".
						 "FROM #__adsmanager_ads as a ".
						 "LEFT JOIN #__adsmanager_adcat as adcat ON a.id = adcat.adid ".
						 "RIGHT JOIN #__adsmanager_categories as c ON adcat.catid = c.id ".
						 "WHERE $published ".
						 "GROUP BY c.id ".
						 "ORDER BY c.parent,c.ordering,c.id";
		//echo $query;
		$this->_db->setQuery($query);
						 
		$list = $this->_db->loadObjectList();
							 
		// establish the hierarchy of the menu
		$tree = array();
		// first pass - collect children
		if(isset($list))
		{
			foreach ($list as $v ) {
				$pt 	= $v->parent;
				$list_temp 	= @$tree[$pt] ? $tree[$pt] : array();
				array_push( $list_temp, $v );
				$tree[$pt] = $list_temp;
			}
		}
		$nbcontents = $this->calc_nb_ads(0,$tree);
		
		return $tree;
	}

	function calc_nb_ads($id,&$cats) {
		$nb_ads = 0;
		if (@$cats[$id]) {	
			$nb = count($cats[$id]);
			for($i=0;$i < $nb;$i++)
			{
				if (!isset($cats[$id][$i]->not_empty))
					$cats[$id][$i]->num_ads = 0;

				$cats[$id][$i]->num_ads += $this->calc_nb_ads($cats[$id][$i]->id,$cats);			
				$nb_ads += $cats[$id][$i]->num_ads;				
			}
		}
		return $nb_ads;
	}
	
	function recurseSearch ($rows,&$list,$catid){
		if(isset($rows))
		{
			foreach($rows as $row) {
				if ($row->parent == $catid)
				{
					$list[]= $row->id;
					$this->recurseSearch($rows,$list,$row->id);
				} 
			}
		}
	}
}